(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define(['comms.websocket','student','modules/debug'], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('comms.websocket'),
        require('student'),
        require('modules/debug'),
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
      root.NSLibrary.Transmit = factory(); //NSLibrary.Transmit || {};
  }
}(this, function(Comms, CSParams, debug) {
  let gBigId = 1; // auto incrementing unique id when sending bigneasy packets
  var TX = {}
  class Transmit {
    constructor(cid) {
      if (cid === undefined) {
          debug("undefined CID supplied:");
          // console.trace();
          // debug(Contents(d));
      }

      this.cid = cid;
      // this.d = d;
      this.utf8 = CSParams.Connections[cid] ?
                      CSParams.Connections[cid].utf8
                      : false;

      TX[cid] = this;
      return this;
    }

    // Big N Easy
    BigEasy() {
      // sendbigneasy
      // let bigCounter = 0; // TODO - Believe bigCounter should be used for something.
      var bigId = gBigId++;
      var from = 0;
      var to = this.d.length;
      var bytesLeft = to;
      //         console.log("BigEasy", this.cid.charCodeAt(0))
      while (bytesLeft > 0) {
        // bigCounter++;
        var more;
        var thisLen;
        if (bytesLeft <= 928 - 11) {
          thisLen = bytesLeft;
          more = 0;
        } else {
          thisLen = 928 - 11;
          more = 1;
        }

        bytesLeft -= thisLen;
        var dBig =
        String.fromCharCode(154) +
        String.fromCharCode(0) +
        String.fromCharCode(to & 255) +
        String.fromCharCode((to >> 8) & 255) +
        String.fromCharCode((to >> 16) & 255) +
        String.fromCharCode((to >> 24) & 255) +
        String.fromCharCode(bigId & 255) +
        String.fromCharCode((bigId >> 8) & 255) +
        String.fromCharCode((bigId >> 16) & 255) +
        String.fromCharCode((bigId >> 24) & 255) +
        String.fromCharCode(more) +
        this.d.substr(from, thisLen);
        from += thisLen;
        var toSend = btoa(this.cid + dBig);
        if (tcpConnected) {
          tcpPage.postMessage({ data: dBig });
        } else {
          Comms.send(toSend);
        }

        //alert("send big from=" + from + ", to=" + to + ", more=" + more);
      }
      // debug("BIGNEASY", bigCounter);
    }

    // ASCII Socket
   ASock() {
        let msg = this.cid + this.d.replace(/\u20AC/g, String.fromCharCode(0x80));
  //         console.info(msg)
  //         console.info(msg, contents(msg));
        Comms.send(btoa(msg));
    }

    // UTF Socket
   USock() {
        Comms.send(btoa(this.cid + this.d));
    }


   //  // Array of UTF-16 character codes
   // function SendArray(array) {
   //      transmit.Push(String.fromCharCode(...array));
   //  }

    // Attempt to send, optimistically
   Push(string, max = 5, tries = 0) {
        const { readyState } = Comms.instance.websocket;
        const clamp = Math.ceil(max / 2);
        const halt = tries >= max;
        const abort = readyState > 1 ? tries >= clamp : false;
        const delay = (tries + 1) * 50;

        // CLOSING or CLOSED - Try to send but abort sooner
        if (halt || abort) {
            console.warn("WebSocket message not sent. State:[%s] Tries:[%s]", readyState, tries);
            return tries;
        }

        // OPEN - all good lets return home.
        if (readyState === 1) {
            Comms.send(string);
            return tries;
        }

        // CONNECTING - increment attempts and retry
        // timeout delay is increased relative to attempts
        setTimeout(() => {
            transmit.Push(string, max, tries + 1);
        }, delay);
    }

    // Send
    Send(d) {
      this.d = d;

      if (!d)
      {
        // Nothing to send
        console.warn("send requested with no payload");
        return;
      }
        //return if not connected
        if (Comms.instance.websocket.readyState !== 1 && !tcpConnected) {
            console.log("websocket not ready")
            return;
        }

        if (this.d.length <= 928) {
            // send small
            if (tcpConnected) {
                tcpPage.postMessage({ data: this.d });
                return;
            }

            if (this.utf8) {
                this.USock();
            } else {
                this.ASock();
            }
        } else {
            this.BigEasy();
        }
    }

    static senddata(cid,d)
    {
      var tx = TX[cid]
      if (tx){
        return tx.Send(d)
      } else {
        return new Transmit(cid).Send(d);
      }
    }
  }

  return Transmit;
}));
