var NSLibrary = NSLibrary || {};
(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define([
        'student',
        'accept',
        'background/subscription',
        'background/thumb/videoStream',
        'models/Tab',
        'models/TabData',
        'modules/extension',
        'comms.websocket',
        'comms.nc.protocol',
        'comms.webrtc',
        'modules/debug',
        'on/lifecycle',
      ], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('student'),
        require('accept'),
        require('background/subscription'),
        require('background/thumb/videoStream'),
        require('models/Tab'),
        require('models/TabData'),
        require('modules/extension'),
        require('comms.websocket'),
        require('comms.nc.protocol'),
        require('comms.webrtc'),
        require('modules/debug'),
        require('on/lifecycle'),
      );
  } else {
      // Browser globals (root is window)
      root.console.debug(root);
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
      // root.NSLibrary.Comms = NSLibrary.Comms || {};
      // root.NSLibrary.Comms.commands = NSLibrary.Comms.commands || {};

      // import CSParams from "./student.js";
      // import getNCAccept from "./accept.js";

      // var window = window || {};
  }
}(this, function(CSParams, getNCAccept, Subscription, Stream, Tab, TabData, extension, Comms, Protocol, WebRTC, debug, lifecycle) {
      var { gHeartBeat } = window;
      var NEWLINE = 10;
      const NC_ACCEPT = getNCAccept();

      signatures = {
        prefix: getCharArray("CMD="), //[67, 77, 68, 61],
        OPEN_REPLY: getCharArray("CMD=OPEN_REPLY"),
        CONNECT: getCharArray("CMD=CONNECT"),
        HANGUP: getCharArray("CMD=HANGUP"),
        PIN_RESULT: getCharArray("CMD=PIN_RESULT"),
        PIN_CLEAR_RESULT: getCharArray("CMD=PIN_CLEAR_RESULT"),
        ACK: getCharArray("CMD=ACK"),
        OTHER: getCharArray("CMD=")
      };

      function getCharArray(string) {
        // returns Array of char codes
        return string.split("").map(c => c.charCodeAt(0));
      }

      function match(item, target) {
        if (!target) {
          return false;
        }

        if (item.length > target.length) {
          return false;
        }

        for (var i in item) {
          if (item[i] !== target[i]) {
            return false;
          }
        }

        return true;
      }

      function OPEN_REPLY(d) {
        //alert("OnOpenReply. nothing to do. ignore it ");
        //SERVER_VERSION
        if (!/SERVER_VERSION=/.test(d)) return;
        CSParams.ServerVersion = d.substring(
          d.indexOf('SERVER_VERSION=') + 15,
          d.indexOf('\n', d.indexOf('SERVER_VERSION=') + 15)
        );
        gUsedMacAddress = d.substring(
          d.indexOf('MAC=') + 4,
          d.indexOf('\n', d.indexOf('MAC=') + 4)
        );
        gUsedIPAddress = d.substring(
          d.indexOf('CLIENT_ADDR=>') + 13,
          d.indexOf('\n', d.indexOf('CLIENT_ADDR=>') + 11)
        );
        announceRoom(sessionStorage.room || ''); // We are announcing the room here, why not ANNOUNCE THE ACTUAL ROOM!!

        CSParams.Opened = true;
      }

      function CONNECT(d) {
        if (!window || !window.chrome) return;
        chrome.storage.local.set({connectionState: 'connected_TUTOR'});
        debug('CONNECT RECEIVED');
        clearTimeout(CSParams.reconnectMode.expiryHandler);
        // Stream.confirmStream(true);
        cidIndex = d.indexOf('CONNECTION_ID=');
        termIndex = d.indexOf('\n', cidIndex + 14);
        cidt = d.substring(cidIndex + 14, termIndex); // textual version of cid, sent back in connect_reply

        // if (/* ALREADY CONNECTED TO TUTOR */)
        // {
          //     // Connect Received, already connected.
          //     debug('ALREADY CONNECTED');
          //     // debug('IGNORING CONNECTION: ' + cidt);
          //     // return;
          // }

          Comms.instance.HEARTBEAT();

          CSParams.powerMode = 'system';
          chrome.power.requestKeepAwake(CSParams.powerMode);
          debug('(CONNECT) Request KeepAwake: ' + CSParams.powerMode);

          debug('CONNECTION ESTABLISH CID: ' + cidt);
          // find connection_id=xxx, and use xxx when replying. assume connection_id= is second item
          CSParams.ControlName = d.substring(
            d.indexOf('CONTROL_NAME=') + 13,
            d.indexOf('\n', d.indexOf('CONTROL_NAME=') + 13)
          );

          //cid = chr(cidt & 255) + chr((cidt >> 8) & 255) + chr((cidt >> 16) & 255) + chr((cidt >>> 24) & 255);
          cid = String.fromCharCode(
            cidt & 255,
            (cidt >> 8) & 255,
            (cidt >> 16) & 255,
            (cidt >>> 24) & 255
          );

          //alert("OnCmdConnect, cidt=" + cidt + "..., cidlen=" + cid.length);

          Comms.instance.CONNECT_REPLY(cidt);

          //Control/Tutor is trying to connectcid = Need to send nc_flush and nc_accept
          var flush = String.fromCharCode(
            Protocol.FLUSH,
            0, 1, 64, 24, 0, 0, 1, 159, 13, 0, 0, 224, 7);

            extension.senddata(cid, flush);

            extension.senddata(cid, NC_ACCEPT);

            // we've sent nc_flush and nc_accept, so now update the state machine in csParams.Connections (expecting nc_login)
            CSParams.Connections[cid] = _Conn(cid, cidt, 1);
            CSParams.ActiveConnection = CSParams.Connections[cid];
            if (CSParams.tickle[cid]) {
              window.clearInterval(CSParams.tickle[cid]);
            }

            CSParams.tickle[cid] = window.setInterval(function() {
              extension.senddata(
                cid,
                String.fromCharCode(Protocol.TICKLE, 0)
              );
            }, 20000);

            // debug('SPT - setPollTimeout');
            // setTimeout(function(){
              //     debug('SPT - FIRE');
              //     pollSelectedTab();
              // },1500);
        }

        function PIN_RESULT(view) {
          var from = view.indexOf(NEWLINE) + 1;
          var to = view.indexOf(NEWLINE, from);
          return String.fromCharCode
          .apply(String, view.subarray(from, to))
          .replace('PIN=', '');
        }

        function PIN_CLEAR_RESULT(view) {
          var from = view.indexOf(NEWLINE) + 1;
          var to = view.indexOf(NEWLINE, from);
          return String.fromCharCode
          .apply(String, view.subarray(from, to))
          .replace('RESULT=', '');
        }

        function ACK() {
          debug('ACK');
          // if(!gHeartBeat) return;
          Subscription.on.ackTimeout.clearInterval();
          // window.clearInterval(gHeartBeat.action);
          lifecycle.isActive();
        }

        function jsonStringHandler(string) {
          //
          let json;

          try {
            json = JSON.parse(string);
          } catch (e) {
            // console.log('plaintext [%s]', string);
            return string;
          }

          if (WebRTC) {
            WebRTC.message(string);
          }

          // parse json and action key triggers
          return json;
        }

        function stringHandler(d) {
          // Do Message Conversion to String
          var sendString = '64 - ';

          d = d ? `${d}` : ''; // cast as String;
          var args = d.match(/^(cmd=)([^\n]+)?/i) || [null, null, null];
          var cmd = args[1];
          var value = args[2];

          // if the message has no CMD prefix then delegate
          // to the JSON based message interpretor
          if (d && !cmd) {
            // console.log('Not standard CMD message [%s]', d);
            jsonStringHandler(d);
            return d;
          }

          // if the message has a CMD=JSON then
          // extract the DATA property and delegate
          if (cmd && /^json$/i.test(value)) {
            const json = d.match(/cmd=json\ndata=([^\n]+)\n/i) || [null, null];
            jsonStringHandler(json[1]);
            return d;
          }

          // CMD type command proterties
          if (d.substr(0, 15) === 'CMD=OPEN_REPLY\n') {
            debug(sendString + 'OPEN_REPLY');
            commands.process.OPEN_REPLY(d);
          } else if (d.substr(0, 12) === 'CMD=CONNECT\n') {
            debug(sendString + 'CONNECT');
            commands.process.CONNECT(d);
          } else if (d.substr(0, 10) === 'CMD=HANGUP') {
            debug(sendString + 'HANGUP');
            commands.process.HANGUP(d);
          } else if (d.substr(0, 14) == 'CMD=PIN_RESULT') {
            var parts = d.split('\n');
            gPin = parts[1].replace('RESULT=', '');
          } else if (d.substr(0, 7) == 'CMD=ACK') {
            ACK();
          } else if (d.substr(0, 4) == 'CMD=') {
            // Unknown Command Message.
            debug('CMD message Unknown' + d);
          }

          // require return value for unit testing
          return value;
        }

        function binaryHandler(d) {
          var s;
          var sendString = '0x - ';

          if (!match(commands.signatures.prefix, d)) {
            return false;
          } else if (match(signatures.OPEN_REPLY, d)) {
            // Do Message Conversion to String
            debug(sendString + 'OPEN_REPLY');
            s = Comms.Commands.convertBinaryToString(d, d.byteLength);
            commands.process.OPEN_REPLY(s);
          } else if (match(signatures.CONNECT, d)) {
            debug(sendString + 'CONNECT');
            s = Comms.Commands.convertBinaryToString(d, d.byteLength);
            commands.process.CONNECT(s);
          } else if (match(signatures.HANGUP, d)) {
            debug(sendString + 'HANGUP');
            s = Comms.Commands.convertBinaryToString(d, d.byteLength);
            commands.process.HANGUP(s);
          } else if (match(signatures.PIN_RESULT, d)) {
            gPin = PIN_RESULT(d);
          } else if (match(signatures.PIN_CLEAR_RESULT, d)) {
            // result not used.
            // result = PIN_CLEAR_RESULT(d);
          } else if (match(signatures.ACK, d)) {
            ACK();
          } else {
            // Unknown Command Message.
          }
        }

        /**
         * Internal
         */

         function _Conn(cid, cidt, sm)
         {
             var connection = { stream:'', thumbi:0, thumbs:0, thumbw:0, thumbh:0, thumblast:'', webpoll:0, appidlast:0, apptitlelast:'', weburllast:'', webtitlelast:'', redirect:'', includes:[], excludes:[], webflag:0, utf8:false };
             connection.cid = cid;
             connection.cidt = cidt;
             connection.sm = sm;
             connection.thumbnailType = 'image/png';
             return connection;
         }

        //// PUBLIC INTERFACE

        commands = {
          signatures,
          match,
          process: {
            OPEN_REPLY,
            CONNECT,
            HANGUP: function() {
              return false;
            },
            PIN_RESULT,
            PIN_CLEAR_RESULT,
            ACK
          },
          interpret: {
            string: stringHandler,
            binary: binaryHandler
          }
      };

      // NSLibrary.Comms.commands = commands;
      return commands;
}));
