(function (factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define(['student','modules/debug'], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('student'),
        require('modules/debug')
      );
  } else {
      // Browser globals (root is window)
      // root.NSLibrary.content = factory.apply(NSLibrary.
  }
}(function(CSParams, debug) {
  const device = {
    power: { switchMode: switchPowerMode }
  };

  function switchPowerMode()
  {
    debug('switch powerMode: ' + ((CSParams.powerMode) ? CSParams.powerMode :'off'));
    if (CSParams.powerMode)
    {
      debug('request powerMode: ' + CSParams.powerMode);
      chrome.power.releaseKeepAwake();
      chrome.power.requestKeepAwake(CSParams.powerMode);
    } else {
      debug('releaseKeepAwake');
      chrome.power.releaseKeepAwake();
    }
  }

  return device;
}));
