(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define([
        'student',
        'comms.websocket',
        'models/Tab',
        'background/CLIENT',
        'chatlib',
        'showlib',
        'device',
        'background/thumb/videoStream',
        // 'settings',
        // 'background/storage',
        // 'pubsub',
        // 'comms.nc',
        // 'lib/batch',
        // 'comms.commands',
        // 'models/useridentity',
        'models/register',
        // 'modules/extension',
        // 'modules/initialize',
        // 'modules/image',
        // 'socket',
        // 'background/events',
        'on/lifecycle'
      ], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('student'),
        require('comms.websocket'),
        require('models/Tab'),
        require('background/CLIENT'),
        require('chatlib'),
        require('showlib'),
        require('device'),
        require('background/thumb/videoStream'),
        //
        // require('settings'),
        // require('background/storage'),
        // require('pubsub'),
        // require('comms.nc'),
        // require('lib/batch'),
        // require('comms.commands'),
        // require('models/useridentity'),
        require('models/register'),
        // require('modules/extension'),
        // require('modules/initialize'),
        // require('modules/image'),
        // require('socket'),
        // require('background/events'),
        require('on/lifecycle')
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function(
  CSParams,
  WSComms,
  Tab,
  CLIENT,
  Chat,
  Show,
  Device,
  Stream,
  //
  // settings,
  // storage,
  // PubSub,
  // NC,
  // sq,
  // COMMANDS,
  // identity,
  Register,
  // extension,
  // initialize,
  // Image,
  // Socket,
  lifecycle) {
  function doDisconnect(keepOpen, reason)
  {
      chrome.storage.local.set({connectionState: "disconnected"});
      if (CSParams.Opened)//  && !tcpConnected)
      {
          debug("DISCONNECTED");

          // TODO: HEARTBEAT

          // debug('De-Register HeartBeat '+gHeartBeat.event);
          // window.clearInterval(gHeartBeat.event);
          // gHeartBeat.event = undefined;
          CSParams.Connections = {};
          if (WSComms.instance.websocket && WSComms.instance.websocket.readyState <2 && !keepOpen){
              var code = 1000;
              var message = 'Disconnect';
              if (reason && reason.code) {
                  code = reason.code;
                  message = (reason.message) ? reason.message : message;
              }

              WSComms.instance.websocket.close(code, message);
          }
          Stream.disable();
          cancelSurvey();
          cancelRegister();
          CSParams.Room.Name = '';
          CLIENT.View.isScraping = 0;
          Show.endShow();

          if (CLIENT.View)
          {
            CLIENT.View.isViewRestart = 1;
          }

          CLIENT.Lock.unlockClient();

          // TODO: Make static methods in chat class accessible.
          if (Chat.eject)
          {
            Chat.eject();
          }

          if (Chat.endChat)
          {
            Chat.endChat();
          }

          CSParams.powerMode = null;
          window.setTimeout(Device.power.switchMode,90000);
          debug('(doDisconnect) 90S switch powerMode: ' + CSParams.powerMode);

          if (UserAck){
              if (UserAck.userAckId=="userack"){
                  chrome.notifications.clear("userack", function(){});
              }

              UserAck.acknowledged = 0;
          }

          window.clearInterval(thumbnailTimer);
          clearTickles();
      }
  }
  function doDisconnectPromise(keepOpen, reason)
  {
    return new Promise(function(resolve){
      doDisconnect(keepOpen, reason);
      resolve();
    });
  }

  function cancelSurvey()
  {
      CSParams.Survey.Cid = '';
      //gSurveyQuestion = "";
      CSParams.SurveyAnswers = '';
      //chrome.browserAction.setIcon({path:"School32.png"});
      //chrome.browserAction.setPopup({popup:""});
      Tab.Remove('Survey');
      Tab.Remove('SurveyResults');
  }

  function cancelRegister()
  {
    CSParams.Register.Cid = '';

    if(Tab.Remove('Register'))
    {
      CSParams.Register = new Register('');
    }
  }

  function clearTickles()
  {
      for (var conn in CSParams.tickle)
      {
          window.clearInterval(CSParams.tickle[conn]);
          delete CSParams.tickle[conn];
      }
  }

  return {
    reset: doDisconnect,
    resetNext: doDisconnectPromise,
    Survey: cancelSurvey,
    Register: cancelRegister
  };
}));
