(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define(['utf8'], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('utf8')
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function(UTF8) {
  function Get(d, count){
      return function(offSet)
      {
          var flags = 0;
          for (i=0; i< count; i++)
          {
              flags += (d.charCodeAt(i+offSet) << (8*i));
          }

          return flags;
      };
  }

  function Check(flags)
  {
      return function(bitValue){ return (flags & bitValue) ? true : false; };
  }

  function CheckAssign(flags, cid)
  {
      return function(bitValue, Assign, value){
          var success = flags & bitValue;
          if (success) {
              Assign(UTF8.Decode(value, cid));
          }

          return success;
      };
  }

  return {Get, Check, CheckAssign};
}));
