var NSLibrary = NSLibrary || {};
NSLibrary.Client = NSLibrary.Client || {};
NSLibrary.Client.Keyboard = NSLibrary.Client.Keyboard || {};

(function(keyboard) {

    keyboard.shiftStatus = false;
    keyboard.ctrlStatus = false;
    keyboard.altStatus = false;
    keyboard.altGRStatus = false;
    keyboard.numLockStatus = false;
    keyboard.capsLockStatus = false;
    keyboard.scanCodes = undefined;


    function doBackSpace() {

        chrome.tabs.executeScript(null, {code: 'oField = document.activeElement;  var iCaretPos = oField.selectionStart; oField.value = oField.value.substring(0,iCaretPos-1) + oField.value.substring(iCaretPos); oField.selectionStart = iCaretPos-1;oField.selectionEnd = iCaretPos-1;' });

    }

    function doDelete() {

        chrome.tabs.executeScript(null, {code: 'oField = document.activeElement;  var iCaretPos = oField.selectionStart; oField.value = oField.value.substring(0,iCaretPos) + oField.value.substring(iCaretPos+1); oField.selectionStart = iCaretPos;oField.selectionEnd = iCaretPos;' });

    }

    function setShift() {
        keyboard.shiftStatus = true;
    }

    function setCtrl() {
        keyboard.ctrlStatus = true;
    }

    function setAlt() {
        keyboard.altStatus = true;
    }
    function setAltGR() {
        keyboard.altGRStatus = true;
    }
    function setNumLock() {
        keyboard.numLockStatus = true;
    }
    function toggleCapsLock() {
        keyboard.capsLockStatus = !keyboard.capsLockStatus;
    }


    keyboard.modifiers = {
        'SHIFT': setShift,
        'CTRL': setCtrl,
        'ALT': setAlt,
        'ALTGR': setAltGR,
        'BACKSPACE': doBackSpace,
        'DELETE': doDelete,
        'CAPSLOCK': toggleCapsLock,
        'NUMLOCK': setNumLock
    };

    keyboard.languageMap = {
        'en-gb' : 'en',
        'en-us' : 'us'
    };

    (function() {

        var getJSON = function(url, callback) {
        var x = window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
        x.onreadystatechange = function() {
            if (x.readyState === 4) {

                if (x.status === 200) {
                    if (callback) {
                        callback(x.responseText);
                    }
                }
                if (x.status === 0) {
                     getJSON(chrome.extension.getURL('../keyboard/us.txt'), callback);
                }
            }
        };

        x.open('GET', url, true);
        x.send(null);

        };
        var fileToGet = keyboard.languageMap[navigator.language.toLowerCase()];
        if (!fileToGet) {
            fileToGet = 'us';
        }


        getJSON(chrome.extension.getURL('../keyboard/' + fileToGet + '.txt'), function(scanCodes) { keyboard.scanCodes = JSON.parse(scanCodes); });

    }());









    keyboard.sendScanCode = function(scanCode, extended) {

        //extended is currently not used - but probably will need to be for extra chars
        extended = extended;
        var keyToPress = keyboard.getKey(scanCode);
        if (keyToPress !== undefined || keyboard.scanCodes.special[scanCode] !== undefined) {

            if (keyboard.scanCodes.special[scanCode] === undefined) {
                chrome.tabs.executeScript(null, {code: "var textEvent = document.createEvent('TextEvent');textEvent.initTextEvent('textInput', true, true, null, '" + keyToPress + "', 1, 'en-US');document.body.dispatchEvent(textEvent);"});
            }else {
                keyboard.modifiers[keyboard.scanCodes.special[scanCode]].call();
            }
        }
    };

    keyboard.getKey = function(scanCode) {

        if (keyboard.altStatus) {
            scanCode += 2000;

        }else if (!keyboard.capsLockStatus && keyboard.shiftStatus) {
            scanCode += 1000;
        }

        var keyToPress = keyboard.scanCodes[scanCode];
        if (keyboard.capsLockStatus && !keyboard.shiftStatus && keyToPress >= 'a' && keyToPress <= 'z') {
            keyToPress = keyboard.scanCodes[scanCode + 1000];
        }
        if (keyboard.capsLockStatus && keyboard.shiftStatus && keyToPress >= '0' && keyToPress <= '9') {
            keyToPress = keyboard.scanCodes[scanCode + 1000];
        }


        return keyToPress;
    };



    keyboard.sendAscii = function(ascii) {
        chrome.tabs.executeScript(null, {code: "var textEvent = document.createEvent('TextEvent');textEvent.initTextEvent('textInput', true, true, null, '" + String.fromCharCode(ascii) + "', 1, 'en-US');document.body.dispatchEvent(textEvent);"});

    };

})(NSLibrary.Client.Keyboard);
