(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define('lib/batch', [], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory();
  } else {
      // Browser globals (root is window)
      var NSLibrary = root.NSLibrary || {};
      NSLibrary.squash = factory();
  }
}(this, function() {
  var tokens = {
		recycleSocket: 0,
		windowResize: 0,
    identityAuth: 0,
    desktopStream: 0
	};

  var tokenStrings = {};
	//squash.token = {};

	for (var label in tokens)
	{
		tokenStrings[label] = label.toString();
	}

  function squash(token, squashDuration){
    if (!tokens[token])
    {
      // Create
      tokens[token] = { validity: Date.now() };
    }

    var fn = function(request){
      var t = tokens[token];

      return new Promise(function(resolve, reject) {
        if (Date.now() >= t.validity) {
          t.validity = Date.now() + squashDuration;
            resolve(request);
        }
      });
    };


    fn.expire = function(){
      return new Promise(function(resolve, reject) {
        tokens[token].validity = Date.now()+squashDuration;
        // Immediately expire token, then fire later.
        setTimeout(resolve,squashDuration);
      });
    };

    return fn;
  }

  return {
    squash: squash,
    token: tokenStrings
  };
}));
