(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define(['utf8'], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('utf8')
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function(UTF8) {
  class Register {
    constructor(Cid)
    {
        this.Cid = Cid;
        this.Flags = 0;
        this.Teacher = '';
        this.Room = '';
        this.Lesson = '';
        this.Student = false;

      return this;
    }

    student(values){
      return new Promise(resolve => {
        let { firstName, lastName, userName, className, studentID, custom1, custom2} = values;
        var regstr = '';
        var flags = 0;
        if (userName) {
          flags |= 1;
          regstr += userName + z;
        }
        else if (firstName) {
          flags |= 1;
          regstr += firstName + z;
        }
        if (lastName) {
          flags |= 2;
          regstr += lastName + z;
        }
        if (className) {
          flags |= 4;
          regstr += className + z;
        }
        if (studentID) {
          flags |= 8;
          regstr += studentID + z;
        }
        if (custom1) {
          flags |= 16;
          regstr += custom1 + z;
        }
        if (custom2) {
          flags |= 32;
          regstr += custom2 + z;
        }

        var res = 1;
        var reg = String.fromCharCode(162) + z +
          String.fromCharCode(flags & 255) + String.fromCharCode((flags >> 8) & 255) + z2 +
          String.fromCharCode(res) + z +
          UTF8.Encode(regstr, this.Cid) + z;

        resolve(reg);
      });
    }
  }

  return Register;
}));
