(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define([
        'comms.nc.protocol',
      ], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('comms.nc.protocol'),
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function(protocol) {
  let sysinfo = {
    shortcode: undefined,
    string: undefined
  };

  let manifest = chrome.runtime.getManifest();

  // chrome platform is 1200 (4B0h)
  sysinfo.string = String.fromCharCode(protocol.SYSINFO, 0, 176, 4);

  if (manifest.name.indexOf("Manager")>-1){
    sysinfo.shortcode = 'AVS';
  } else {
    sysinfo.shortcode = 'AVS';
  }

  sysinfo.string += sysinfo.shortcode;
  sysinfo.string +=' V' + manifest.version + String.fromCharCode(0, 0, 0, 0, 0, 0);

  return sysinfo;
}));

