(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define([], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory();
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function() {
	function GetOptionData()
	{
		////////////////////////////////////////////////////////////////////////////////////
		// Get the appropriate data specified in the options page
		////////////////////////////////////////////////////////////////////////////////////

		var option_data = {
			// meta URL
			// allowActiveMetaURL: $('#active-meta-url').is(':checked'),
			// metaURL: $('#meta-url').val().trim(),
			allowManualClientName: $('#allow-manual-client-name').is(':checked'),
			allowManualMacName: $('#allow-manual-macname').is(':checked'),

			gatewayAddress: $('#gatewayAddress').val().trim(),
			gatewayPort: $('#gatewayPort').val().trim(),

			roomMode: function(){
				var res, mode = $('input[name="room"]:checked').val();
				switch(mode)
				{
						case 'roomSpecified':
							res = 'Fixed';
							break;
						case 'roomList':
							res = 'List';
							break;
						case 'roomManual':
							res = 'Manual';
							break;
				}
				return res;
			},
			roomName: $('#roomName').val().trim(),
			roomList: $('#roomList').val().trim(),
			keyboardLayout: function(){
				var lang = $('#keyboardLayout option:selected').text();
				if(lang === 'American')
					return 'en-US';
				else
					return 'en-GB';
			},
			passPhrase: $('#pass-output').text()

		};

		return option_data;
	}

	function GetDefaultJSONObject()
	{
		var json = {
						"options": {

							"Value": {

								"allowManualClientName": false,
								"allowManualMacName": false,
								"gateways": [{ "address": "", "port": 123 }],
								"room": {
									"mode": ""
								},
								"keyboardLayout": "en-gb"
							}
						}
					};

		return json;
	}

	function generateExportFile()
	{
		var json = GetDefaultJSONObject();
		var options = GetOptionData();

		////////////////////////////////////////////////////////////////////////////////////
		// Populate the JSON Object with option data
		////////////////////////////////////////////////////////////////////////////////////

		//if(options.allowActiveMetaURL)
		//	json.options.Value.activeMetaURL = options.metaURL;

		// Allowing fields for client name and mac name
		json.options.Value.allowManualClientName = options.allowManualClientName;
		json.options.Value.allowManualMacName = options.allowManualMacName;

		// Gateway Details
		if (options.gatewayAddress == '' || options.gatewayAddress == "undefined"){
			delete(json.options.Value.gateways);
		} else {
			json.options.Value.gateways[0].address = options.gatewayAddress;
			json.options.Value.gateways[0].port = (options.gatewayPort !== '' ) ? parseInt(options.gatewayPort, 10) : 443 ;
		}

		// Room Modes
		json.options.Value.room.mode = options.roomMode();
		if(options.roomMode() === 'Fixed'){
			if (options.roomName === '') {
				delete(json.options.Value.room);
			} else {
				json.options.Value.room.name = options.roomName;
			}
		} else if(options.roomMode() === 'List') {
			if (options.roomList === '') {
				delete(json.options.Value.room);
			} else {
				json.options.Value.room.list = options.roomList;
			}
		}

		// Pass Phrase
		if(options.passPhrase !== '')
			json.options.Value.passKey = options.passPhrase;

		// Keyboard Layout
		json.options.Value.keyboardLayout = options.keyboardLayout();

		return json;
	}

	return { generateExportFile };
}));
