(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define([
        'comms.websocket',
        'logger',
        'background/subscription',
        'modules/initialize',
        'on/lifecycle',
      ], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('student'),
        require('comms.websocket'),
        require('logger'),
        require('background/subscription'),
        require('modules/initialize'),
        require('on/lifecycle'),
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function(WSComms, log, Subscription, initialize, lifecycle) {
    let { debug } = log;

    // let ackTimeout = { eventHandle: undefined };
    // 66) csParams.lifecycle.isActive = function(){
    // 67)     var state = csParams.lifecycle;
    // 68)     return (state.time + 60000 > Date.now());
    // 69) };

    /**
     * EVENT HEARTBEAT
     */
       // 8807abda (Aaron Rumbold       2014-11-21 15:02:56 +0000  771)             gHeartBeat.action = window.setInterval(function(){
       // 8807abda (Aaron Rumbold       2014-11-21 15:02:56 +0000  772)                 debug('ACK Timeout - Closing.');
       // 17e74418 (Aaron Rumbold       2015-09-21 15:48:00 +0000  773)                 closeConnection({code:4002, message: 'POLL Timeout'});
       // 8807abda (Aaron Rumbold       2014-11-21 15:02:56 +0000  774)                 window.clearInterval(gHeartBeat.action);
       // 9813f169 (Aaron Rumbold       2016-02-18 15:39:15 +0000  775)                 setTimeout(function(){document.dispatchEvent(csParams.lifecycle.Interval);},1900);
       // 8807abda (Aaron Rumbold       2014-11-21 15:02:56 +0000  776)             }, 25000);

    // Create Ack Timeout entity.
    new Subscription(Subscription.keys.ackTimeout, ackTimeout)
        .setInterval(10000)
        .clearInterval();
    new Subscription(Subscription.keys.heartbeat, eventHeartBeat).registerEvent();

    function ackTimeout()
    {
        debug('ACK Timeout - Closing.');
        closeConnection({ code:4002, message: 'POLL Timeout' });
        Subscription.on.ackTimeout.clearInterval();
        // window.clearInterval(ackTimeout.eventHandle);
        setTimeout(() => Subscription.on.interval.call() ,1900);
    }

    function eventHeartBeat(e)
    {
      debug('HBE');
      // e.cancelBubble = true;
      HeartBeat(WSComms.instance.websocket);
    }

    function HeartBeat(skt)
    {
      debug('Heartbeat()');
      window.clearInterval(ackTimeout.eventHandle);
      var show = NSLibrary.Client.Show;

      // Poll on HeartBeat
      WSComms.instance.POLL(ts);

      if (!lifecycle.check())
      {
        // No Packets for previous 60 Seconds
        // TODO: RE-enable
        // if (show.isShowing)
        // {
        //   // No Show Packets
        //   debug('Showing - No Packets, Closing Socket.');
        //   closeConnection({ code:4001, message: 'No Packets Received' });
        // }

        if (skt.readyState == 1)
        {
          var ts=(function(){ var d = new Date(); return d.toISOString(); })();
          debug('Socket Poll:'+ts);
          Subscription.on.ackTimeout.setInterval(25000);
          // ackTimeout.eventHandle = window.setInterval(, 25000);

          WSComms.instance.POLL(ts);
        } else {
          debug('Invalid Socket State('+ skt.readyState +') -- NOT POLLING');
          initialize();
        }
      }
    }
}));
