(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define(['comms.websocket',
        'background/subscription',
        'socket',
        'logger'
      ], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
      require('comms.websocket'),
      require('background/subscription'),
      require('socket'),
      require('logger')
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function(
  WSComms,
  Subscription,
  Socket,
  log) {
      var reconnectWorker = new Worker("/js/reconnectWorker.js");

      reconnectWorker.onmessage = reconnectReceived;
      
      function reconnectReceived() {
        log.debug("Reconnect Received...");
        chrome.storage.local.set({ connectionState: "connecting" });
        WSComms.mechanism.HeartBeat();
        Subscription.on.interval.clearInterval();
        Subscription.on.interval.setInterval(60000);
        Socket.accelerateReconnect();
      }

      return {trigger: reconnectReceived}
}));
