(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD
    define(factory);
  } else if (typeof exports === 'object') {
    // Node, CommonJS-like
    module.exports = factory();
  } else {
    // Browser globals (root is window)
    root.ns = root.ns || { content: {} };
    root.ns.content.platform = factory();
  }
}(this, function () {
  function isChromeOS() {
    return new Promise(function (resolve, reject) {
      chrome.runtime.getPlatformInfo(function (pi) {
        if (pi && pi.os == 'cros') {
          resolve(pi);
        } else {
          console.log(`Invalid Platform: '${pi.os}', expected: 'cros'`);
          chrome.browserAction.disable();
        }
      });
    });
  }

  return {
    isChromeOS: isChromeOS
  };
}));