(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define([
        'background/subscription',
        'modules/extension',
        'on/lifecycle',
        'comms.commands',
        'comms.websocket',
        'comms.nc',
        'student'
    ], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('background/subscription'),
        require('modules/extension'),
        require('on/lifecycle'),
        require('comms.commands'),
        require('comms.websocket'),
        require('comms.nc'),
        require('student')
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function(Subscription,extension,lifecycle,COMMANDS,WSComms,NC,CSParams) {
  // SOCKETS
  function message(evt)
  {
      var binary = (evt.data instanceof ArrayBuffer);
      if (binary)
      {
          var dview = new Uint8Array(evt.data);

          if (COMMANDS.match(COMMANDS.signatures.prefix, dview))
          {
              // CMD Specified.
              COMMANDS.interpret.binary(dview);
          } else {
              // Non Command Received, Treat as NC.
              lifecycle.isActive()
              NC.Process(WSComms.Commands.convertBinaryToString(dview, evt.data.byteLength));
          }
      } else {
          // Legacy Conversion
          var d = atob(evt.data);
          if (d.substr(0,4) === "CMD=")
          {
              // CMD Specified
              COMMANDS.interpret.string(d);
          } else {
              lifecycle.isActive()
              NC.Process(d);
          }
      }
  }

  function error(evt) {
    window.chrome.storage.local.set({ connectionState: "disconnected" });
    //DONT REMOVE THIS OR THE BUILD COMPLAINS
    debug(evt);
  }

  function open() {
    debug('Socket now open:' + (this));
    window.chrome.storage.local.set({ connectionState: "connected_NCS" });
    clearTimeout(CSParams.reconnectMode.expiryHandler);
    lifecycle.isActive();
    CSParams.reconnectMode.expiryHandler = setTimeout(CSParams.reconnectMode.clear, 10000);
    // Reset Opened to false if new Socket opening.
    CSParams.Opened = false;

    lifecycle.openHandshake = window.setTimeout(extension.handshake, 500);
  }

  function close() {
    // Logged through Trace in doDisconnect.
    window.chrome.storage.local.set({ connectionState: "disconnected" });
    debug('Socket(HB: ' + gHeartBeat.event +').onclose: (RS:' + this.readyState + ')');
    disconnect.reset();
    CSParams.Opened = false;
    setTimeout(function(){ document.dispatchEvent(Subscription.on.interval.call); },1500);
  }

    return {
      message,
      error,
      open,
      close
    };
}));
