(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define([
        'student',
        'comms.websocket',
        'modules/image',
      ], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('student'),
        require('comms.websocket'),
        require('modules/image'),
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function(CSParams, WSComms, Image) {

  // Add identifier for each subscription to the key array.
  let keys = ['interval','plugin','heartbeat','ackTimeout'];

  // Event name can be overridden.
  let override = {
   plugin: 'pluginEvent'
  };

  var inflate = (structure) => Object.assign(...(keys.map(structure)));

  class Subscription {
    constructor(key, handler) {
      this.handler = handler;
      this.key = key;
      this.id = undefined;

      return this;
    }
    /**
     * Invoke the Handler
     */
    call()
    {
      Subscription.last[this.key] = Date.now();
      if (this.handler) { this.handler(); }
    }

    /**
     * Intervals
     */
    setInterval(interval)
    {
      this.id = window.setInterval(this.handler, interval);
      return _subscribe.apply(this);
    }

    clearInterval() {
      window.clearInterval(this.id);
    }

    /**
     * Events
     */
    registerEvent(handler)
    {
      document.addEventListener((key => {
        let r = override[key];
        if (r) { return r; }
        else { return key }
      })(this.key), handler);
      return _subscribe.apply(this);
    }

    removeEvent(key) {
      document.removeEventListener((key => {
        let r = override[key];
        if (r) { return r; }
        else { return key; }
      })(this.key), this.call);
    }

    /**
     * Timeouts
     */
     setTimeout(duration)
     {

     }

     clearTimeout(key){

     }
  }

  /**
   * Magic strings are Evil.
   */
  Subscription.keys   = inflate(key=>( {[key]:key      } ));
  Subscription.on     = inflate(key=>( {[key]:undefined} ));
  Subscription.last   = inflate(key=>( {[key]:undefined} ));


  function _subscribe()
  {
    Subscription.on[this.key] = this;
    return this;
  }

  return Subscription;
}));
