(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define(['settings'], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('settings')
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function(settings) {
  let moduleName = "webrtc";
  let area = "managed";
  var defaultConfig = {
    "sourceType": [
              "screen"
            ],
            "constraints": {
              "audio": false,
              "video": true,
              "frameRate": {
                "ideal": 15,
                "min": 0.2
              }
            }};

  function getConfig(){
    return new Promise(resolve => {
        settings
          .load(moduleName, area)
          .then(data => {
            if (data) {
              resolve(data);
            } else {
              resolve(defaultConfig);
            }
          });
    });
  }

    return { getConfig };
}));
