define(function(){
  // CONFIG
  var level = 0;
  let _DEBUG = false;

  var target = writeConsole;

  // LOG LEVELS
  const levels = {
    off: 0,
    all: 1,
    info: 2,
    debug: 3,
    error: 4
  };

  // PUBLIC INTERFACE
  var PUBLIC = {
    levels,
    debug,
    setup: config,
    log: DEBUG,
    all: nolog,
    info: nolog,
    error: nolog,
  };


  // LOGGERS
  function nolog(){
  }

  function debug(msg)
    {
        if (_DEBUG){
            console.debug( "DEBUG: "+ new Date().toISOString() + ' ' + msg);
            if (localStorage.debugDest){
                chrome.runtime.sendMessage(localStorage.debugDest,{ time:Date.now(), note: msg});
            }
        }
    }

    // debug.set = function(value)
    // {
    //   DEBUG = (value) ? true : false;
    // }


  function writeRemote()
  {
    // Not Implemented;
    var args = Array.prototype.slice.call(arguments);
    args.unshift("REM:");
    writeConsole.apply(this,args);
  }

  function writeConsole()
  {
    console.log.apply(this,arguments);
  }

  // CHANGE SETTINGS
  function config(values)
  {
    if (values.target)
    {
      switch(values.target)
      {
        case "console":
          target = writeConsole;
          break;
        case "remote":
          target = writeRemote;
          break;
        case "disabled":
          target = nolog;
      }
    }

    if (values.hasOwnProperty('level'))
    {
      // Default to no logging
      PUBLIC.error=nolog;
      PUBLIC.debug=nolog;
      PUBLIC.info=nolog;
      PUBLIC.all=nolog;

      switch(values.level)
      {
        case levels.off:
          // Already set.
          break;
        case levels.all:
          PUBLIC.all=ALL;
          break;
        case levels.info:
          PUBLIC.info=INFO;
          break;
        case levels.debug:
          PUBLIC.debug=DEBUG;
          break;
        case levels.error:
          PUBLIC.error=ERROR;
          break;
      }

      level = values.level;
    }
  }

  function ERROR()
  {
    var args = Array.prototype.slice.call(arguments);
    args.unshift("ERROR:");
    target.apply(this,args);
  }

  function DEBUG()
  {
    var args = Array.prototype.slice.call(arguments);
    args.unshift("DEBUG:");
    target.apply(this,args);
  }

  function INFO()
  {
    var args = Array.prototype.slice.call(arguments);
    args.unshift("INFO:");
    target.apply(this,args);
  }

  function ALL()
  {
    var args = Array.prototype.slice.call(arguments);
    args.unshift("ALL:");
    target.apply(this,args);
  }

  return PUBLIC;
});
