(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define([], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
      require()
      );
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function() {
    function make(val,sender)
    {
        var cn = arguments.callee.name;

        new Promise(function(resolve,reject)
        {
            var fr = new FileReader();
            fr.onload = function()
            {
              crypto.subtle.digest({ name:"SHA-256" }, fr.result)
              .then(function(dg)
              {
                var a8 = new Uint8Array(dg);
                var op = [];
                for (var i in a8){
                  op.push(('0'+a8[i].toString(16)).slice(-2));
                }

                resolve(op.join(''));
              });
            };

            fr.onerror = function(){
                reject("makePPH" + fr.error);
            };

            fr.readAsArrayBuffer(new Blob([chrome.runtime.getManifest().name + val]));
        }).then(function(e){
            var evt = new CustomEvent(cn, { detail: e });
            sender.ownerDocument.defaultView.window.dispatchEvent(evt);
      });
    }
    return { make };
}));
