var NSLibrary = NSLibrary || {};
(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define(['modules/copyright'], () => {
        let translate = factory();
        NSLibrary.Translate = translate;
        return translate;
      });
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory();
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function() {
  var gTranslations = '';

  var getLocale = function() {
      if (window.navigator.language=="nb"){
          return "no";
      }
      if (window.navigator.language.substr(0,2)=="en"){
          return "en";
      }
      return window.navigator.language.replace("-","_");
  };

  var getTranslation = function(key) {

      if (gTranslations[key]) {
          return gTranslations[key].message;
      } else {
          //This line return Capilitlised words - see ucwords() in PHP
          return (key + '').toLowerCase().replace(/_/g, ' ').replace(/^([a-z\u00E0-\u00FC])|\s+([a-z\u00E0-\u00FC])/g, function($1) { return $1.toUpperCase(); });
      }
  };

  var loadTranslations = function() {
      var matches = document.querySelectorAll('[data-i18n-content]');
      for (var i = 0; i < matches.length; i++) {
          matches[i].innerHTML += getTranslation(matches[i].getAttribute('data-i18n-content'));
      }
  };

  var loadPlaceholders = function() {
      var matches = document.querySelectorAll('[data-i18n-placeholder]');
      for (var i = 0; i < matches.length; i++) {
          matches[i].placeholder = getTranslation(matches[i].getAttribute('data-i18n-placeholder'));
      }
  };

  var getJSON = function(url, callback) {
              var x = window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
              x.onreadystatechange = function() {
                  if (x.readyState === 4) {

                      if (x.status === 200) {
                          if (callback) {
                              callback(x.responseText);
                          }
                      }
                      if (x.status === 0) {
                           getJSON(chrome.extension.getURL('../_locales/en/messages.json'), loadTranslations);
                      }
                  }
              };

              x.open('GET', url, true);
              x.send(null);
  };

  Translate = function() {
          if (arguments.length === 1) {
              return getTranslation(arguments[0]);
          }
          if (arguments.length === 2) {
              return getTranslation(arguments[0]).replace(/PLACEHOLDER/i, arguments[1]);
          }
          var locale = getLocale();
          getJSON(chrome.extension.getURL('../_locales/' + locale + '/messages.json'), function(data){
              gTranslations = JSON.parse(data);
              loadTranslations(data);
              loadPlaceholders(data);
          });
          switch(locale){
              case 'ar':
                  document.body.dir = 'rtl';
                  break;
              case 'ru':
                  document.body.lang=locale;
                  break;
          }
  };

  return Translate;
}));
