var bgPage = chrome.extension.getBackgroundPage();
bgPage.chatUrl = document.location.href;

require(['modules/translate'], t=>t());

const instance = bgPage.chats.instance;
const {setTarget, sendMessage} = instance;

const main = document.querySelector("#main");
const sendButton = document.querySelector("#sendButton");
const message = document.querySelector("#message");

setTarget(main);

function sendAndClear () {
    sendMessage.call(instance, message.value);
    message.value = "";
    message.focus();
}

sendButton.addEventListener("click", sendAndClear);
message.addEventListener("keyup", e => {
    if (e.keyCode === 13){
        e.preventDefault();
        sendAndClear();
    }
});
