define(['background/observable','modules/translate'], function(ko,Translate) {

    function openHR(){
      chrome.windows.create({url: "helprequest.html", focused:true, type:"popup", width:500, height:336}, function(){});
      //bgPage.sendHelpRequest("This is a message");
    }

    function setRoom() {
      var value = document.getElementById('room').value;
      document.getElementById("status").innerHTML = Translate('OPTIONS_SAVED');
      window.setTimeout(function(){ document.getElementById("status").innerHTML="";},1500);
      chrome.extension.getBackgroundPage().setRoom(value);
      hideSaveButton(localStorage.roomType !== 'roomList');
    }

    function hideSaveButton(hide) {
    	var displayMode = (hide) ? 'none' : 'block';
        document.getElementById("saveBtn").style.display = displayMode;
    }

    function ClientMenuViewModel(op) {
      Translate();
      var self = this;
      var roomType = localStorage.roomType;
      var roomList = localStorage.roomList;
      var room = localStorage.room;
      var roomSpecified = roomType === 'roomSpecified';
      var textToAdd;

      if (roomType == 'roomList') {

        textToAdd = '<select id="room" style="min-width:108px">';
        textToAdd += '<option></option>';

        roomList = roomList.split(',');
        // console.log(bgPage.sessionStorage.room);
        for (var x in roomList) {
           textToAdd += '<option';
           if (roomList[x].trim() == chrome.extension.getBackgroundPage().sessionStorage.room){
              textToAdd += ' selected ';
           }

           textToAdd += '>' + roomList[x] + '</option>';
        }

         textToAdd += "</select>";
      } else {
        room = getSessionRoom(room);

        textToAdd = '<input id="room" style="width:110px" value="' + room + '"';
        if (roomSpecified) {
          textToAdd += ' disabled';
        }
        textToAdd += ' />';
        hideSaveButton(true);
      }

      document.getElementById("roomDesc").insertAdjacentHTML("afterbegin", textToAdd);
      document.getElementById("helpBtn").addEventListener('click', openHR, false);
      document.getElementById("saveBtn").addEventListener('click', setRoom, false);
      $('#room').on('keyup', function(e){
        var currentRoom = getSessionRoom(localStorage.room);
        hideSaveButton(e.target.value == currentRoom);
      });

      self.gwConnectState = ko.observable("connecting");
      self.gw2ConnectState = ko.observable("connecting");
      self.gatewayPath = ko.observable(op.gatewayPath);

      return self;
    }

    var vm = new ClientMenuViewModel({
      gatewayPath: (localStorage.gatewayAddress|| '') + ':' + localStorage.gatewayPort
    });

/*    function checkEnter(e) { //e is event object passed from function invocation
      var characterCode; //literal character code will be stored in this variable

      if (e && e.which) { //if which property of event object is supported (NN4)
        e = e;
        characterCode = e.which; //character code is contained in NN4's which property
      } else {
        e = event;
        characterCode = e.keyCode; //character code is contained in IE's keyCode property
      }

      if (characterCode == 13) { //if generated character code is equal to ascii 13 (if enter key)
        setRoom();
      } else {}
    }*/

      function getSessionRoom(room)
      {
        if (chrome.extension.getBackgroundPage().sessionStorage && chrome.extension.getBackgroundPage().sessionStorage.room)
        {
          room = chrome.extension.getBackgroundPage().sessionStorage.room;
        }

        return room;
      }

    function updateGatewayPath() {
      var activeSocket = chrome.extension.getBackgroundPage().getActiveSocket();
      if (activeSocket)
      {
          vm.gatewayPath(activeSocket.url);
      }
    }

    function storageChanged(change) {
      if (change.connectionState){
        updateGatewayPath();
        if (change.connectionState.newValue){
            vm.gwConnectState(change.connectionState.newValue);
        } else {
            vm.gwConnectState(change.connectionState);
        }
      }
    }

    function setOp()
    {
      // console.log((e);
      $('.hidden').each(function(){$(this).removeClass('hidden');});
      //$(':disabled').each(function(){$(this)

      chrome.storage.managed.get("clientMenu", updateGatewayPath);

      chrome.storage.onChanged.addListener(storageChanged);

      $('div#pass').addClass('hidden');
      // Call KO Bind Here
      ko.applyBindings(vm);
      chrome.storage.local.get("connectionState", storageChanged);
    }

    setOp();

    String.prototype.trim=function(){return this.replace(/^\s+|\s+$/g, '');};

    return {};
 });
