require(['modules/translate'], function(Translate){
function setupPage() {
  var bgPage = chrome.extension.getBackgroundPage();

  var teacher = bgPage.getTeacherName();
  var lesson = bgPage.getLessonName();
  var room = bgPage.getRoom();
  var student = bgPage.getStudent();
  var userName = student.UserName;

  if (userName) {
    document.getElementById('userName').value = localStorage.userName;
  } else {
    document.getElementById('userName').style.display = "none";
  }

  document.getElementById('fullName').style.display = 'block';

  function displayInline(item, id, custom)
  {
    if (item) {
        document.getElementById(id).style.display = "inline";
        document.getElementById(id).previousElementSibling.style.display = "inline-block";
        if (custom) { custom(document.getElementById(id).previousElementSibling); }
        document.getElementById(id).focus();
    } else {
        document.getElementById(id).style.display = "none";
        document.getElementById(id).previousElementSibling.style.display = "none";
    }
  }

  function displayBlock(item, id)
  {
    if (item !== '') {
      document.getElementById(id).style.display = 'block';
      document.getElementById(id+'Label').style.display = 'block';
      document.getElementById(id+'Name').innerHTML = item;
    }
  }

  if (student) {
    displayInline(student.FirstName,'firstName');
    displayInline(student.Surname,'lastName');
    displayInline(student.ClassName,'className');
    displayInline(student.StudentID,'studentID');
    displayInline(student.Custom1,'custom1', function(item){item.innerHTML = student.Custom1;});
    displayInline(student.Custom2,'custom2', function(item){item.innerHTML = student.Custom2;});
  }

  displayBlock(teacher, 'teacher');
  displayBlock(lesson, 'lesson');
  displayBlock(room, 'room');

  document.getElementById('registerBtn').addEventListener('click', doRegister, false);
  document.querySelector("input:not([style*='display:none'])").focus();
}

function doRegister() {
  var bgPage = chrome.extension.getBackgroundPage();
  var fields = document.querySelectorAll("input:not([style*='display: none'])");
  var missingData =0;
  for (var i=0;i<fields.length;i++){

      if (fields[i].value === ""){
        missingData =1;
        break;
      }
  }

  if (!missingData){
    bgPage.studentRegister({
      firstName:  document.getElementById('firstName').value,
      lastName:   document.getElementById('lastName').value,
      userName:   document.getElementById('userName').value,
      className:  document.getElementById('className').value,
      studentID:  document.getElementById('studentID').value,
      custom1:    document.getElementById('custom1').value,
      custom2:    document.getElementById('custom2').value
    });
  }else{
    var status = document.getElementById('status');

    status.innerHTML = Translate('PLEASE_PROVIDE_YOUR_PERSONAL_DETAILS_FOR_THE_LESSON_REGISTER');
    setTimeout(function() {
      status.innerHTML = '&nbsp;';
    }, 1200);
  }
}

  setupPage();
  Translate();
});
