(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define(['ui/piechart', 'modules/translate'], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory();
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function(PieChart, Translate) {
    let btnColours = [['#3d77b2'], ['#4bad85'], ['#c0c0c0'], ['#cc4d35'], ['#c6b202'], ['#8d52ab']];
    var data = [];
    var bgPage = chrome.extension.getBackgroundPage();
    var buttons = bgPage.getSurveyResults().split('\r\n');
    Translate();

    delete buttons[buttons.length - 1];
    for (var button in buttons) {
      var values = buttons[button].split('% ');
      data[data.length] = [values[1], parseFloat(values[0])];
    }

    // create a PieChart.
    showSurvey();
    data = data.join().split(',');
    var segments = [];
    var labels = [];
    for (var i = 0; i < data.length; i++) {
      if (i % 2) {
         segments[segments.length] = 360 * (data[i] / 100);
      }else {

         labels[labels.length] = [data[i]];
      }
    }

    PieChart('chart', {includeLabels: true, labels: labels, data: segments, colors: btnColours, dropShadow: true});

    function querySt(ji) {
      var hu = window.location.search.substring(1);
      var gy = hu.split('&');
      for (var i = 0; i < gy.length; i++) {
        var ft = gy[i].split('=');
        if (ft[0] == ji) {
          return ft[1];
        }
      }
    }

    function showSurvey() {
      var bgPage = chrome.extension.getBackgroundPage();

      document.getElementById('surveyQuestion').innerHTML = bgPage.getSurveyQuestion();

      var buttons = bgPage.getSurveyResults().split('\r\n');

      delete buttons[buttons.length - 1];
      var btnCount = 0;
      for (var button in buttons) {
        var newdiv = document.createElement('button');
        newdiv.style.cssFloat = 'left';
        newdiv.style.fontWeight = 'normal';
        newdiv.style.backgroundColor = btnColours[btnCount];
        newdiv.innerHTML = buttons[button];

        document.getElementById('surveyAnswers').appendChild(newdiv);
        btnCount++;
      }
      var maxWidth = 0;
      var allBtns = document.getElementsByTagName('button');
      var i;
      for (i = 0; i < allBtns.length; i++) {
        if (allBtns[i].clientWidth > maxWidth) {
            maxWidth = allBtns[i].clientWidth;
          }
      }

      for (i = 0; i < allBtns.length; i++) {
       allBtns[i].style.width = maxWidth;
      }
    }
}));
