(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define(() => factory(root));
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(root);
  } else {
      // Browser globals (root is window)
      // root.ns = root.ns||{ content: {} };
      // root.ns.content. = factory(root.ns.content.);
  }
}(this, function() {
  var _state = 0;

  const mouse = { x:0, y:0, click };
  // var { gMouseState = 0,  gMouseX = 0,  gMouseY = 0 };

  // mouse state has changed:
  // if state&1 then Left Btn is down
  // if state&2 then Right Btn is down
  // if state&4 then Middle Btn is down
  function click(state)
  {
      if (state != _state) { // something changed
          if ((state & 1) && !(_state & 1)) {
           // left button down @ gMouseX, gMouseY
              mouseClick();
          }
          // if (!(state & 1) && (gMouseState & 1)) { // left button up @ gMouseX, gMouseY
          //   // Do Nothing - Test for another time!
          // }
          _state = state;
      }
  }

  function mouseClick() {
      chrome.tabs.executeScript(null,
        {
          code:
            'var x = ' +
            mouse.x +
            '; var y = ' +
            mouse.y +
            '; var el = document.elementFromPoint(x,y); if ((el.nodeName === "INPUT" && el.type!=="submit" && el.type!=="button")||el.nodeName === "TEXTAREA" ||el.nodeName === "SELECT"){ console.log(x);var remX = x-el.offsetLeft;var remY = y-el.offsetTop;var newX = Math.round((remX/8))+(Math.floor((el.offsetWidth)/8)*Math.floor(remY/16));/*console.log(newX); console.log(el.offsetWidth + " " + remX + " " + remY );*/el.setSelectionRange(newX,newX);}else{el.click();}'
        },
        function() {
          if (chrome.runtime.lastError) {
            console.error(chrome.runtime.lastError.message);
          }
        });
  }

  return mouse;
}));
