(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define(['models/register','models/survey'],factory);
      // define(function(){
      //   root.CSParams = factory();
      //   return root.CSParams;
      // });
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('models/register'),
        require('models/survey')
      );
  } else {
      // Browser globals (root is window)
      root.NSLibrary.CS.Params = factory(root.Register);
  }
}(this, function(Register, Survey) {
  const csParams = {
    Opened: false,
    Survey: new Survey('','',''),
    Room: { Name: '', Changed:false },
    ServerVersion: null,
    ControlName: '',
    Debug: 1,
    Connections: {},
    ActiveConnection: null,
    Register: new Register(),
    Show: { Width: null, Height: null, context: null },
    ScreenDimensions: { width: null, height: null },
    QA: { Cid:null , Tab:null, RoundNum: null, ThinkingTime:null, AnswerBtnAvailable:null, TimeLimit:null, PlaySounds:null },
    Feedback: { Cid:null , Tab:null, ImageSet: null, NumberAnswers: null,Question: null, AnswerText: null, ButtonConfiguration: null },
    TabStore: { Register: null, Survey: null, SurveyResults: null },
    pktCh: {},
    powerMode: null,
    reconnectMode: { active:0, id: undefined, expiryHandler: undefined, clear: clearReconnect },
    tickle: {},
    get: {
      currentWindow: currentWindow
    }
  };

  function clearReconnect() {
      csParams.reconnectMode.active = 0;
  }

  function currentWindow()
  {
      return new Promise(function(resolve,reject){
          // Promise (success, failure)
          chrome.windows.getCurrent(function(w){
              if (w)
              {
                  resolve(w);
              } else {
                  if (chrome.runtime.lastError)
                  {
                      var msg = chrome.runtime.lastError.message || "Unable to get current Window";
                      debug(msg);
                      reject(msg);
                  }
              }
          });
      });
  }

  return csParams;
}));
