(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
      // AMD
      define(['student','modules/debug'], factory);
  } else if (typeof exports === 'object') {
      // Node, CommonJS-like
      module.exports = factory(
        require('student'),
        require('modules/debug')
    );
  } else {
      // Browser globals (root is window)
      // root.NSLibrary.content = factory.apply(NSLibrary.
      root.NSLibrary.UTF8 = factory(root.NSLibrary.CS.Params);
  }
}(this, function(CSParams) {
    var utf8Connections = {};
    function Required(s)
    {
        if (s){
            for (i=0;i<s.length;i++)
            {
                if (s.charCodeAt(i)>255)
                    return true;
            }
        }

        return false;
    }

    function Encode(s, cid)
    {
        debug("in ENCODE");
        if(utf8Connections[cid])
        {
            return this.ForceEncode(s);
        }
        else if (this.Required(s)){
            utf8Connections[cid] = true;
            this.ForceEncode(s);

        } else 
            return s.replace(/\u20AC/g,String.fromCharCode(0x80));
    }

    function ForceEncode(s)
    {
        return unescape(encodeURIComponent(s));
    }

    function PrefixEncode(s)
    {
        return (this.Required(s)) ? String.fromCharCode(0xEE, 0xBB, 0xBF) + this.ForceEncode(s) : s;
    }

    function Decode(s, cid)
    {
        debug("in DECODE");
        return decodeURIComponent(escape(s));
        // if(utf8Connections[cid] || true)
        // {
        // }
        // else
        // {
        //     return s.replace(/\x80/g,String.fromCharCode(0x20ac));
        // }
    }

    function ForceDecode(s){
      return decodeURIComponent(escape(s));
    }

    function SetUTF8(cid)
    {
      utf8Connections[cid] = true;
    }

  return {
    Required,
    Encode,
    ForceEncode,
    PrefixEncode,
    Decode,
    ForceDecode,
    SetUTF8
  };
}));
