# WebRTC set-up

Currently the WebRTC proof-of-concept requires a fully autonomous WebSocket server. Please follow these instructions to get the student, teacher (PEERs) and SERVER working.



## Server

Download the POC repository, Install node dependencies and run the server

```
git clone git@github.com:fliptopbox/webrtc-poc.git
cd webrtc-poc/WebRTC/Chrome/server/
npm install
node server.js
```

This will start the server on your machine, please note the ***IP address***. you will require this for the next two steps.



## Peer (Student and teacher)

Until we have integrated the RTC messaging with the NCS server we need to tell the respective extensions to bypass the standard messaging channel and use a separate WebSocket.

You will need to get the **Norcross** and **BigCreek** repos and edit the following files:



Checkout the feature branch `git checkout feature/webrtc` on **both** repos then ...



**BigCreek\js\modules\models\thumbnail.js**

```
line 188: ....
        dataset = {
            ...dataset,
            // augment WebSocket details
            moderator: true,
            room: "Science",
            host: "10.0.75.1", <------------ change IP address
            port: 8080
        }
....
```
**Norcross\js\comms.webrtc.js**

```
line 25: ...
    let bypass = "10.0.75.1:8080"; <------------ change IP address
...
```

Reload the respective extensions and ensure the node server is getting connections.



Run the BigCreek Chrome App as normal. When you see the list of students roll your mouse over a selected student and wait for the thumbnail to enlarge, then click the large image and a RTC viewer window will pop-up. Currently, it functions just like the former POC teacher App, and will allow the teacher to see the respective student's screen.
